<?php

// CookieAuth by Rob Fisher -- http://www.robfisher.net/wiki
// Cookie authentication method adapted from PHP5 and MySQL Bible by
// Tim Converse and Joyce Park with Clark Morgan
// ISBN 0764557467
// See Chapter 44: User Authentication

require_once('local/config.php');

// Replace pmWiki's default authorisation function
$AuthFunction = 'CookieAuth';

// Where do we go after a successful login?  User can set this in config.php.
SDV($CookieAuthSuccessUrl, "pmwiki.php");

// Security hash
SDV($CookieAuthMd5Hash, 'This string makes it hard to generate fake cookies.  Change it for security.');

// Add the login action handler
$HandleActions['login'] = 'HandleLogin';


function CookieAuth($pagename,$level,$authprompt=true) {
  global $AuthRealmFmt,$AuthDeniedFmt,$DefaultPasswords,
    $AllowPassword,$GroupAttributesFmt;
  $page = ReadPage($pagename);
  if (!$page) { return false; }
  @$passwd = $page["passwd$level"];
  if ($passwd=="") { 
    $grouppg = ReadPage(FmtPageName($GroupAttributesFmt,$pagename));
    @$passwd = $grouppg["passwd$level"];
  }
  if ($passwd=="") return $page;	// page does not require login

  if (IsLoggedIn()) {
    return $page;
  }

  return false;
}


function IsLoggedIn() {
  global $CookieAuthMd5Hash;

  // blank username cookie could be easy to fake
  if($_COOKIE['username'] == "") {
    return false;
  }

  if ($_COOKIE['username'] && $_COOKIE['id_hash']) {
    $hash = md5($_COOKIE['username'].$CookieAuthMd5Hash);
    if ($hash == $_COOKIE['id_hash']) {
      return true;
    } else {
      return false;
    }
  }
  else {
    return false;
  }
}


// Returns true on successful login
function CookieLogin() {
  global $DefaultPasswords;

  $username = $_POST['username'];
  $password = $_POST['password'];

  // username and password required
  if ($username == "" || $password == "") {
    return false;
  }

  $correctpassword = $DefaultPasswords['admin'];
  $cryptresult = crypt($password,$correctpassword);

  if($cryptresult == $correctpassword) {
     SetCookies($username);
     return true;
  }
  else {
    return false;
  }
}


function CookieLogout() {
  setcookie('username', '', (time()+2592000), '/', '', 0);
  setcookie('id_hash', '', (time()+2592000), '/', '', 0);
}


function SetCookies($username) {
  global $CookieAuthMd5Hash;

  $id_hash = md5($username.$CookieAuthMd5Hash);

  setcookie('username', $username, (time()+2592000), '/', '', 0);
  setcookie('id_hash', $id_hash, (time()+2592000), '/', '', 0);
}


function HandleLogin() {
  global $CookieAuthSuccessUrl;
  
  // log out if already logged in.
  if (IsLoggedIn()) {
    CookieLogout();
    $_COOKIE['username'] = '';
    $logged_in_str = '<p>You are now logged out.</p>';
  }
  
  if ($_POST['submit'] == 'Login') {
    if(CookieLogin()) {
      // Redirect to successful login page
      header("Location: $CookieAuthSuccessUrl");
    }
    else {
      $result_str = "<P class=\"errormess\">$result</P>";
    }
  }

  $php_self = $_SERVER['PHP_SELF'];
  $php_self .= '?action=login';

  $login_page = <<< EOLOGINPAGE
  <html>
  <head>
  <title>PmWiki Login</title>
  </head>

  <body>
  <h1>PmWiki Login</h1>

  $logged_in_str
  $result_str

  <form action="$php_self" method="post">
  <p>
  Username: <input type="text" name="username" size="10" />
  Password: <input type="password" name="password" size="10" /?
  <input type="submit" name="submit" value="Login">
  </p>
  </form>

  </body>
  </html>
EOLOGINPAGE;

  echo $login_page;
  exit;
}


?>